=== debian/changelog ===
tiledarray (1.0.0-1) unstable; urgency=medium

  * New upstream release (Closes: #982712).
  * debian/watch: Updated.
  * debian/upstream/metadata: New file.
  * debian/control (Build-Depends): Add libboost-serialization-dev and
    libtas-dev.
  * debian/control (Build-Depends): Bump libmadness-dev version to
    0.10.1+git20200818.eee5fd9f-3.
  * debian/patches/skip_valeev_group_cmake_toolkit.patch: New patch, skips
    cloning the Valeev group cmake toolkit.
  * debian/patches/external_madness_config.h_dir.patch: New patch, fixes the
    location of madness' config.h header.
  * debian/control (Build-Depends): Replaced debhelper with debhelper-compat (=
    12).
  * debian/compat: Removed.
  * debian/rules: Enable parallel build of testsuite.
  * debian/rules (override_dh_auto_test): Remove MPI execution of testsuite.
  * debian/rules (override_dh_auto_build): Removed, and move building the
    testsuite ...
  * debian/rules (override_dh_auto_test): ... here.
  * debian/rules (override_dh_auto_configure): Add TILEDARRAY_INSTALL_LIBDIR.
  * debian/patches/cmake_pkg-config_location.patch: New patch, fixes the
    pkgconfig install location to TILEDARRAY_INSTALL_LIBDIR/pkgconfig.

 -- Michael Banck <mbanck@debian.org>  Sun, 02 Jan 2022 17:46:05 +0100
