=== debian/control ===
Source: tiledarray
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               libblas-dev,
               libboost-dev,
               libboost-serialization-dev,
               libbtas-dev,
               libeigen3-dev,
               liblapack-dev,
               libmadness-dev (>= 0.10.1+git20200818.eee5fd9f-3),
               libmpich-dev,
               libtbb-dev,
               mpich,
               openssh-client,
               pkg-config
Standards-Version: 3.9.8
Homepage: https://github.com/ValeevGroup/tiledarray
Vcs-Browser: https://salsa.debian.org/debichem-team/tiledarray
Vcs-Git: https://salsa.debian.org/debichem-team/tiledarray.git

Package: libtiledarray-dev
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Block-Sparse Tensor Library (development files)
 TiledArray is a scalable, block-sparse tensor library that is designed
 to aid in rapid composition of high-performance tensor expressions,
 appearing for example in many-body quantum mechanics. It allows users
 to compose tensor expressions of arbitrary complexity that closely
 resembles the standard mathematical notation.
 .
 This package contains the static libraries and the header files.
